/*
   Sample code showing how to draw the "background"
   image used in this assignment.
*/

import java.awt.*;
import javax.swing.*;

/**
   This class instantiates the GUI.
*/
@SuppressWarnings("serial")
public class Hw1_background extends JFrame
{
   public Hw1_background()
   {
      super("Hw1 background");
      this.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
      this.getContentPane().add( new BackgroundPanel() );
      this.pack(); // Let the JPanel determine the size of this JFrame.
      this.setLocationRelativeTo(null); // Center the JFrame in the desktop.
      this.setResizable(false);
      this.setVisible(true);
   }

   public static void main(String[] args)
   {
      SwingUtilities.invokeLater( () -> new Hw1_background() );
   }
}


/**
   The paintComponent() method in this class shows how to
   draw the "background" image used in this assignment.
*/
@SuppressWarnings("serial")
class BackgroundPanel extends JPanel
{
   private static final int X_DIM = 1000;
   private static final int Y_DIM =  500;

   BackgroundPanel()
   {
      this.setPreferredSize( new Dimension(X_DIM, Y_DIM) );
   }

   @Override
   public void paintComponent(Graphics g)
   {
      super.paintComponent(g);
      g.setClip(0, 0, X_DIM, Y_DIM );

      for (int i = 0; i < X_DIM; ++i)
      {
         for (int j = 0; j < Y_DIM; ++j)
         {
            // use the bitwise-or operator, '|', and the remainder operator, '%'
            final int gray = (i | j) % 255;
            g.setColor( new Color(gray, gray, gray) );
            g.drawLine(i, j, i, j);
         }
      }
   }//paintComponent()

}//BackgroundPanel
